<?php
return [
    'method' => 'post',
    'elements' => [

        'report_details' => [
            'markup',
            [
                'label' => _('Important Notes'),
                'markup' => '
                    <p>This report is intended for licensing in the United States only, for webcasters paying royalties via
                    SoundExchange. Learn more about the requirements for reporting and classification on the
                    <a href="https://www.soundexchange.com/service-provider/reporting-requirements/" target="_blank">
                        SoundExchange web site
                    </a>.</p>
                <ul>
                    <li>AzuraCast assumes that your station fits SoundExchange Transmission Category A, "Eligible nonsubscription 
                    transmissions other than broadcast simulcasts and transmissions of non-music programming." If your
                    station does not fall within this category, update the transmission category field accordingly.
                    <li>The data collected by AzuraCast meets the SoundExchange standard for Actual Total Performances (ATP)
                    by tracking unique listeners across all song plays. All other information is derived from the metadata of the
                    uploaded songs themselves, and may not be completely accurate.</li>
                    <li>Reporting requirements for SoundExchange may change at any time. AzuraCast is non-commercial community-built
                    software and cannot guarantee that its reporting format will always be up-to-date.</li>
                    <li>You should always verify the report generated by AzuraCast before sending it. In particular, either the ISRC
                    (International Standard Recording Code) or *both* the album and label are required for every row, and may not be 
                    provided in the song metadata. AzuraCast will use external APIs to try to find the ISRC, but you can
                    also use <a href="https://isrc.soundexchange.com" target="_blank">SoundExchange\'s ISRC search tool</a>.</li>
                </ul>',
                'label_class' => 'mb-2',
                'form_group_class' => 'col-sm-12 mt-1',
            ]
        ],

        'start_date' => [
            'text',
            [
                'type' => 'date',
                'label' => _('Report Start Date'),
                'required' => true,
                'label_class' => 'mb-2',
                'form_group_class' => 'col-md-6 mt-1',
            ]
        ],

        'end_date' => [
            'text',
            [
                'type' => 'date',
                'label' => _('Report End Date'),
                'required' => true,
                'label_class' => 'mb-2',
                'form_group_class' => 'col-md-6 mt-1',
            ]
        ],

        'submit' => [
            'submit',
            [
                'type' => 'submit',
                'label' => _('Generate Report'),
                'class' => 'btn btn-lg btn-primary',
                'form_group_class' => 'col-sm-12 mt-3',
            ]
        ],

    ],
];
