<?php

return [
    'method' => 'post',
    'elements' => [

        'report_details' => [
            'markup',
            [
                'label' => __('Important Notes'),
                'markup' => '<p>'.__('This report is intended for licensing in the United States only, for webcasters '
                    . 'paying royalties via SoundExchange. Learn more about the requirements for reporting and classification on the '
                    . '<a href="%s" target="_blank">SoundExchange web site</a>.', 'https://www.soundexchange.com/service-provider/reporting-requirements/'). '</p>'
                    . '<ul>'
                    . '<li>'.__('AzuraCast assumes that your station fits SoundExchange Transmission Category A, "Eligible nonsubscription '
                    . 'transmissions other than broadcast simulcasts and transmissions of non-music programming." If your '
                    . 'station does not fall within this category, update the transmission category field accordingly.').'</li>'
                    . '<li>'.__('The data collected by AzuraCast meets the SoundExchange standard for Actual Total Performances (ATP) '
                    . 'by tracking unique listeners across all song plays. All other information is derived from the metadata of the '
                    . 'uploaded songs themselves, and may not be completely accurate.').'</li>'
                    . '<li>'.__('Reporting requirements for SoundExchange may change at any time. AzuraCast is non-commercial '
                    . 'community-built software and cannot guarantee that its reporting format will always be up-to-date.').'</li>'
                    . '<li>'.__('You should always verify the report generated by AzuraCast before sending it. In particular, either '
                    . 'the ISRC (International Standard Recording Code) or *both* the album and label are required for every row, and may not '
                    . 'be provided in the song metadata. AzuraCast will use external APIs to try to find the ISRC, but you can '
                    . 'also use <a href="%s" target="_blank">SoundExchange\'s ISRC search tool</a>.', 'https://isrc.soundexchange.com').'</li>'
                    . '</ul>',
            ]
        ],

        'start_date' => [
            'text',
            [
                'type' => 'date',
                'label' => __('Report Start Date'),
                'required' => true,
            ]
        ],

        'end_date' => [
            'text',
            [
                'type' => 'date',
                'label' => __('Report End Date'),
                'required' => true,
            ]
        ],

        'submit' => [
            'submit',
            [
                'type' => 'submit',
                'label' => __('Generate Report'),
                'class' => 'btn btn-lg btn-primary',
            ]
        ],

    ],
];